﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AbstructClassTest
{
    abstract class Vehicle
    {
        //プロパティ==========
        public int Speed{get; protected set;}
        public double Gas{get; set;}

        //コンストラクタ==========
        public Vehicle()
            : this(20)
        {
        }

        public Vehicle(double gas)
        {
            this.Speed = 0;
            this.Gas = gas;
        }

        //メソッド==========
        //加速するメソッド(抽象メソッド)
        public abstract void SpeedUp(int sp);

        //減速するメソッド
        public void SpeedDown(int sp)
        {
            //スピードを減らす
            this.Speed -= sp;
            if (this.Speed < 0)  //スピードがマイナスになる場合
            {
                //スピードを0に補正する
                this.Speed = 0;
            }
        }
    }
}
